<script>
import {
  // ok: okay-button-vue-component
  GlButton,
} from 'not-gitlab-ui';
import {
  // ruleid: okay-button-vue-component
  GlButton
} from '@gitlab/ui';

export default {
  components: {
    GlButton
  },
  methods: {
    okayGlButtonReferences() {
      return [
        // ok: button-class-vue
        this.$el.classList.contains('gl-button'),
        // ok: button-class-vue
        this.$el.querySelector('gl-button'),
        // ok: button-class-vue
        this.$el.querySelectorAll('gl-button'),
      ];
    },
  },
  computed: {
    classes() {
      return [
        // ruleid: button-class-vue
        'gl-button',
        // ruleid: button-deprecated-variant
        'btn-info',
        // ruleid: button-deprecated-variant
        'btn-warning',
        // ruleid: button-deprecated-variant
        'btn-success',
      ]
    }
  }
}
</script>
<template>
  <div>
    <!-- ok: button-class-vue -->
    <gl-button>
      I am a good button
    <!-- ok: button-class-vue -->
    </gl-button>

    <!-- ok: button-element-vue -->
    <button>
      I am probably an okay button
    </button>

    <!-- ok: button-element-vue -->
    <button class="emoji-menu-btn text-center js-emoji-btn" type="button"></button>

    <!-- ruleid: button-deprecated-variant-vue -->
    <gl-button variant="success">I have a deprecated variant</gl-button>
    <!-- ruleid: button-deprecated-variant-vue -->
    <gl-button variant="info">I have a deprecated variant</gl-button>
    <!-- ruleid: button-deprecated-variant-vue -->
    <gl-button variant="warning">I have a deprecated variant</gl-button>

    <!-- ruleid: button-element-vue -->
    <button class="gl-button">
      I am a bad button
    </button>

    <!-- ruleid: button-element-vue -->
    <button class="btn">
      I am a bad button
    </button>

    <!-- ruleid: button-element-vue -->
    <button class="btn-foo">
      I am a bad button
    </button>

    <!-- ruleid: button-element-vue -->
    <button class="btn gl-button">
      I am a bad button
    </button>

    <button
      v-if="!showAllPackages && remainingPackages"
      type="button"
      // ruleid: button-element-vue
      class="btn-link btn-show-all-packages"
      @click="handleShowPackages"
    >
      {{ remainingPackages }}
    </button>

    <!-- ruleid: button-element-vue -->
    <button class="gl-button btn">
      I am a bad button
    </button>

    <!-- ok: button-class-vue -->
    <gl-icon class="gl-button-icon" name="slight-smile" />

    <!-- Ignore buttons that should be covered by dropdown rules. -->
    <!-- ok: button-class-vue -->
    <a class="js-sidebar-dropdown-toggle edit-link btn gl-text-gray-900! gl-ml-auto hide-collapsed btn-default btn-sm gl-button btn-default-tertiary float-right" href="#">
      {{ __('Edit') }}
    </a>

    <button
      v-show="!disableCommenting"
      type="button"
      role="button"
      :aria-label="$options.i18n.newCommentButtonLabel"
      // ok: button-element-vue
      class="gl-absolute gl-w-full gl-h-full gl-p-0 gl-top-0 gl-left-0 gl-outline-0! btn-transparent gl-hover-cursor-crosshair"
      data-testid="design-image-button"
      @mouseup="onAddCommentMouseup"
    ></button>
  </div>
</template>
